# Vardoc Update
General instructions on how to update Vardoc

# 1 - Read the release notes to know what had been changed.

For each stable release we will have some notes, and extra steps,
developers need to do to update the last release to the new release.



# 2 - Backups

* Backup your project database.
* Backup your project files.
* Test restore your backups, on a test restore site.

# 3 - Get the packaged files for the new version of Vardoc 8.2.x

* From Drupal website: https://www.drupal.org/project/vardoc
* With the composer using vardoc-project: https://packagist.org/packages/vardot/vardoc-project

# 4 - From your terminal, change directory to the root directory of your
#     project to do the update:

# For Example:

```
Given that we do have a project at the /var/www/html/projects/example folder
  And we do have our custom themes, features, custom modules in
   /var/www/html/projects/example/themes/custom/
   /var/www/html/projects/example/modules/custom/
   /var/www/html/projects/example/sites/default
so on ...
like contributed modules which we had theme added
while working on the project.

  And we opened a terminal console window
  And we changed directory to our project folder
  cd /var/www/html/projects/example in Linux

  When we delete all files and folders, except our changes on Vardoc.
  Then we will be left with only custom changes

  When we copy all Vardoc files
  And we make sure that we do not have any overridden files or folders
     only delete old ones and copy new folder of modules to the same place
```

# 5 - Set the right file permissions.
# 6 - Update composer packages. use "composer outdated"
# $ composer update

  Make sure that you do have modules in the right place.

# 7 - Import Vardoc Core Features and Bundles:

```
 Given that you are logged in with the "webmaster" user
   And the "Features" module is enabled
   And the "Features UI" module is enabled
  When you go to "admin/config/development/features"
  Then you should not see any changed features in the Vardoc core bundle.
  When you click on all "Changed"
  Then you will be able to see all changes
   And you will be able to import new changes if you need them
```

# 8 - Do your Drupal 8 database updates

* By the terminal "drush updb".
* By the web browser by going to "yousite.domain/update.php"

# 9 - Regression test the full site.

* Done :\)

---

--------------------------------------------------------------------------------

# Updating Vardot 8.2.0 to Vardot 8.2.1

## Step #1 Option #1 Vardot 8.2.0 to Vardot 8.2.1
## Copy and Paste 

* For example let us have mysite vardoc folder at:
  "/var/www/html/projects/mysite"

* Use the terminal command to change directory to:
```
 $ cd /var/www/html/projects/mysite/docroot
```

* Delete all old drupal core folders and files
```
 $ rm -rf docroot/modules/contrib
 $ rm -rf docroot/themes/contrib
 $ rm -rf docroot/libraries
 $ rm -rf docroot/profiles/varbase
 $ rm -rf docroot/profiles/vardoc
```
* Copy all new Vardoc files and folders over the old one, you could do this
  from the GUI.
* Be sure that you have deleted all not customized files and folders.
* Be sure that you have all custom module or themes still site.
* Be sure that all new used modules and features are present.
* Change permissions and owner ship for all files and folders to work with
  Drupal standard.
* At this point you will be ready to update the active config and database,
  which you can follow in [Step #2](#step-2-vardot-820-to-vardot-821).

## Step #1 Option #2 Vardot 8.2.0 to Vardot 8.2.1
## Composer Update
    The composer way of Vardoc's procedures to update the base code.
    only if you had build the vardoc site with the
    [vardoc-project](https://github.com/Vardot/vardoc-project/tree/8.x-2.x)
    template.

* For example let us have mysite vardoc folder at:
  "/var/www/html/projects/mysite"

* Use the terminal command to change directory to:
```
 $ cd /var/www/html/projects/mysite/docroot
```
* Be sure that the current "vardoc-project" composer.json file and files are
  the latest

* Delete old composer lock and the vendor folder
```
 $ rm composer.lock
 $ rm vender
 $ rm -rf docroot/modules/contrib
 $ rm -rf docroot/themes/contrib
 $ rm -rf docroot/libraries
 $ rm -rf docroot/profiles/varbase
 $ rm -rf docroot/profiles/vardoc
```
* Run the "composer require vardot/vardoc:8.2.1" command
* ait for composer to finish work
* Be sure not see any issues in the terminal
* At the end of composer work make sure that you can see
  "Writing lock file" and "Generating autoload files" in the terminal
* if the composer finishes work with no errors
* Change permissions and owner ship for all files and folders to work with
  Drupal standard.
* At this point you will be ready to update the active config and database,
  which you can follow in [Step #2](#step-2-vardot-820-to-vardot-821).

## Step #2 Vardot 8.2.0 to Vardot 8.2.1
## Update the active config and database from Vardot 8.2.0 to Vardot 8.2.1

* For example let us have mysite vardoc folder at:
  "/var/www/html/projects/mysite"
* Make sure that all files are updated using (copy and past) or
  (composer require/update).
* Use the terminal command to change directory to:
```
 $ cd /var/www/html/projects/mysite/docroot
```
* Run drush "updb" or go to "/update.php" from the web browser.
* You will see the steps of updates to follow with next steps.
* In your web browser go to "/admin/config/development/features"
* Check all "Changed" features, or you could use the normal config sync
* Follow with each feature to import new changes if you need them.
* Do a regression testing for the site and functional testing to make sure
  that you do not have any change of behaviours in the site.
* At this point you will have the Vardoc site updated to the latest version.


--------------------------------------------------------------------------------
# No upgrade path to update Vardoc 8.x-1.x to 8.x-2.x yet
You will need to manage a migration, or a hard update process.